#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

int rZ, rI, rL, rM;

int Period(int Z, int I, int M, int seed)
{
    static int buf[10000];

    memset(buf, 0, sizeof(buf));

    int len = 0;

    while ( buf[seed] == 0 ) {
        len++;
        buf[seed] = len;
        seed = (Z * seed + I) % M;
    }

    return len - buf[seed] + 1;
}

int main()
{
    int Z, I, M, L;

    int c = 0;
    while ( true ) {
        scanf(" %d %d %d %d", &Z, &I, &M, &L);
        if ( M == 0 ) break;
        printf("Case %d: %d\n", ++c, Period(Z, I, M, L));
    }

    return 0;
}
