#include <stdio.h>
#include <string.h>

char *words[] = 
{
    "zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine", "ten",
    "eleven", "twelve", "thirteen", "fourteen", "fifteen", "sixteen", "seventeen", "eighteen", "nineteen",
    "twenty", "thirty", "forty", "fifty", "sixty", "seventy", "eighty", "ninety", 
    "hundred", "thousand", "million",
    "negative", 
};

enum {
    n0 = 0,
    n100 = 28,
    n1000 = 29,
    nMil = 30,
    nNeg = 31,
};

int findw(char *w)
{
    for ( int i = 0; i <= nNeg; i++ ) 
        if ( strcmp(w, words[i]) == 0 ) return i;
    return -1;
}

int main()
{
    char line[256];

    while ( gets(line) ) {
        int n = 0, r = 0;
        bool neg = false;
        char *tok = strtok(line, " \t\n");

        if ( tok == NULL ) continue;

        while ( tok != NULL ) {
            int m = findw(tok);

            switch ( m ) {
            case n100:  
                r *= 100; 
                break;
            case n1000: 
                n += r * 1000; 
                r = 0;
                break;
            case nMil:  
                n += r * 1000000; 
                r = 0;
                break;
            case nNeg:  
                neg = true; 
                break;
            default:
                if ( m < 20 ) 
                    r += m;
                else if ( m < n100 ) 
                    r += 20 + (m - 20) * 10;
            }

            tok = strtok(NULL, " \t\n");
        }
        n += r;
        if ( neg ) n = -n;

        printf("%d\n", n);
    }

    return 0;
}
